window.Gleam.initSearch([{"doc":"lww_register","title":"lww_register","content":"# lww_register\n\nThe last-write-wins register CRDT.\n\n[![Package Version](https://img.shields.io/hexpm/v/lww_register)](https://hex.pm/packages/lww_register)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/lww_register/)\n\nCRDTs (conflict-free replicated data type) are data structures that can be\ncan be merged in any order and always get the same result at the end.\nThey may be useful for making distributed programs where not all the nodes\nare able to co-ordinate to change agree on program state.\n\n```sh\ngleam add lww_register@1\n```\n\nDocumentation can be found at &lt;https://hexdocs.pm/lww_register&gt;.\n","url":"index.html"},{"doc":"lww_register","title":"LWWRegister","content":"pub opaque type LWWRegister(value)\n A CRDT that is container for a single value.\n\n It also contains a timestamp of the last change, and an id for the node in\n the distributed program that last set the value. \n This id might be the computer hostname or some other unique id.\n\n\nSynonyms:\nlww_register.LWWRegister\nlww_register LWWRegister","url":"lww_register.html#LWWRegister"},{"doc":"lww_register","title":"get","content":"pub fn get(register: LWWRegister(a)) -&gt; a\n Set the register value.\n\nSynonyms:\nlww_register.get\nlww_register get","url":"lww_register.html#get"},{"doc":"lww_register","title":"merge","content":"pub fn merge(\n  left: LWWRegister(a),\n  right: LWWRegister(a),\n) -&gt; LWWRegister(a)\n Merge to registers together.\n\n Whichever register has the highest timestamp will be the one whose value\n remains after the merge.\n\n In the event that both timestamps are the same the one with the greater id\n is used.\n\nSynonyms:\nlww_register.merge\nlww_register merge","url":"lww_register.html#merge"},{"doc":"lww_register","title":"new","content":"pub fn new(value value: a, local_id id: String) -&gt; LWWRegister(a)\n Create a new register with the given value, for the given id.\n\nSynonyms:\nlww_register.new\nlww_register new","url":"lww_register.html#new"},{"doc":"lww_register","title":"set","content":"pub fn set(\n  register: LWWRegister(a),\n  replacement value: a,\n  local_id id: String,\n) -&gt; LWWRegister(a)\n Set the register value and id. Also increments the timestamp.\n\nSynonyms:\nlww_register.set\nlww_register set","url":"lww_register.html#set"},{"doc":"lww_register","title":"lww_register","content":" The last-write-wins register CRDT.\n\n CRDTs (conflict-free replicated data type) are data structures that can be\n can be merged in any order and always get the same result at the end.\n They may be useful for making distributed programs where not all the nodes\n are able to co-ordinate to change agree on program state.","url":"lww_register.html"}]);